VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Switched User Detection"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9945
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   9945
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox Text1 
      Height          =   1455
      Left            =   30
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   630
      Width           =   9345
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Waiting to receive session messages when this User Switches Users..."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   90
      TabIndex        =   1
      Top             =   360
      Width           =   7290
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


'//////////////////////////////////////////////////////////////////////////////////
'*********** Compile to EXE before running...
'//////////////////////////////////////////////////////////////////////////////////

'//////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////
   'This Code was written by
   'Joe Sova, jsova734@comcast.net
   'Especially for Rod Stephens and all the programmers visiting vb-helper.com
   'Please feel free to use it, learn from it, send comments and enjoy it!
'//////////////////////////////////////////////////////////////////////////////////
'//////////////////////////////////////////////////////////////////////////////////

'Use at your own risk! Demo only!
'Especially be carefull with subclassing in the IDE, this could crash your computer!
'Backup, backup, backup!
'I have written it to be as safe as possible, but it IS subclassing...
'I am not responsible!

'This Code Uses Sub Classing which can be quite unstable when run in the IDE,
'so by default it is programmed to only run when compiled to an exe.

'I wrote this code because I needed to understand what was involved in detecting
'when a user "Switches" users from the current user to some other user.
'I wanted to know this because my simple alarm clock app activates and plays sounds
'for ALL users, not just the one that started my app, something I found to be undesireable.

'Although I do not do it here in this generic example, in my own app I set a T/F flag based
'on the CONSOLE_CONNECT / CONSOLE_DISCONNECT messages.
'I use this flag to tell my app to play the sounds or not.

'This generic example shows session changes for all users for demo purposes, however
'I really only need the messages from the current user, otherwise I would have to weed-out
'session messages from other users, this is set by the selection in the load event of this project.

Private Const NOTIFY_FOR_THIS_SESSION As Long = &H0 'Sends session change messages for current user only
Private Const NOTIFY_FOR_ALL_SESSIONS As Long = &H1 'Sends session change messages for all users

Private Declare Function WTSRegisterSessionNotification Lib "wtsapi32" (ByVal hwnd As Long, ByVal dwFlags As Long) As Boolean
Private Declare Function WTSUnRegisterSessionNotification Lib "wtsapi32" (ByVal hwnd As Long) As Boolean
Private RetVal As Boolean 'Not really necessary here, but can be used to confirm success during debugging, should be True if successful
Private IDERunning As Boolean 'Always True if running from IDE, otherwise it's false


Private Sub Form_Initialize()
   Debug.Assert InIDE 'Asserted boolean code only runs in the IDE
End Sub

Private Function InIDE() As Boolean 'Test to see if we are running in the IDE and set IDERunning flag
   IDERunning = True 'Set to True if running from IDE
   InIDE = True 'Debug.Assert needs to have this set, although I never use it again
End Function

Private Sub Form_Load()

'Because sub classing is VERY unstable if run from the IDE, I only subclass from an exe.
'So here, I check if running in the IDE, if NOT then ok to start the subclass function
If IDERunning Then
   MsgBox "This program is running from the IDE, please compile it and run it as an 'exe'."
   Unload Me
Else
   'If running as an exe, go turn on subclassing
   SubClassSession True
   'Select one of the below lines to register form1 to receive session messages from the system, either for the current user or for all users.
   '//////////////////////////////////////////////////////////////////////////////////
   'RetVal = WTSRegisterSessionNotification(Form1.hwnd, NOTIFY_FOR_THIS_SESSION)
   'OR
   RetVal = WTSRegisterSessionNotification(Form1.hwnd, NOTIFY_FOR_ALL_SESSIONS)
   '//////////////////////////////////////////////////////////////////////////////////
   MsgBox "Ok," & vbNewLine & "Now leave this app running (after pressing OK) and switch user, then come back..." & vbNewLine & vbNewLine & "DO NOT LOG OFF! -JUST SWITCH USER."
End If

End Sub

Private Sub Form_Resize()
Text1.Width = Form1.Width - 150
Text1.Height = (Form1.ScaleHeight - Text1.Top) - 30
End Sub

Private Sub Form_Unload(Cancel As Integer)
'If IDERunning Then
   'Must turn off subclassing when exiting
   SubClassSession False
   'The recieve session messages request must be unloaded before closing the app like this
   RetVal = WTSUnRegisterSessionNotification(Form1.hwnd)
'End If
End Sub









