Attribute VB_Name = "Module1"
Option Explicit

Public defWindowProc As Long 'Holds subclass address(handle)
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

'// uMsg value
Const WM_WTSSESSION_CHANGE As Long = &H2B1

'// wParam values:
Const WTS_CONSOLE_CONNECT = &H1          'A session was connected to the console session
Const WTS_CONSOLE_DISCONNECT = &H2       'A session was disconnected from the console session
Const WTS_REMOTE_CONNECT = &H3           'A session was connected to the remote session
Const WTS_REMOTE_DISCONNECT = &H4        'A session was disconnected from the remote session
Const WTS_SESSION_LOGON = &H5            'A user has logged on to the session
Const WTS_SESSION_LOGOFF = &H6           'A user has logged off the session
Const WTS_SESSION_LOCK = &H7             'A session has been Locked
Const WTS_SESSION_UNLOCK = &H8           'A session has been unlocked
Const WTS_SESSION_REMOTE_CONTROL = &H9   'A session has changed its remote controlled status

'//lParam Value:
'lParam shows the (User)Session ID that the wparam represents

On Error Resume Next

Select Case hwnd

   'We requested messages to go to form1 so we look under form1's messages
   Case Form1.hwnd
      
      Select Case uMsg
         
         'When the uMsg is WM_WTSSESSION_CHANGE then wParam contains the description
         'and lparam contains the User that the message refers to.
         Case WM_WTSSESSION_CHANGE
            
            Form1.Text1.Text = Form1.Text1.Text & vbNewLine
            Form1.Text1.Text = Form1.Text1.Text & vbNewLine
            Form1.Text1.Text = Form1.Text1.Text & "Session Changed at " & Time & ", User # "
            Select Case wParam
               Case WTS_CONSOLE_CONNECT 'A session was connected to the console session
                  Form1.Text1.Text = Form1.Text1.Text & lParam & "'s Session was Connected to the Console Session"
               Case WTS_CONSOLE_DISCONNECT 'A session was disconnected from the console session
                  Form1.Text1.Text = Form1.Text1.Text & lParam & "'s Session was Disconnected from the Console Session"
               Case WTS_REMOTE_CONNECT 'A session was connected to the remote session
                  Form1.Text1.Text = Form1.Text1.Text & lParam & "Session was Connected to the Remote Session"
               Case WTS_REMOTE_DISCONNECT 'A session was disconnected from the remote session
                  Form1.Text1.Text = Form1.Text1.Text & lParam & "Session was Disconnected from the Remote Session"
               Case WTS_SESSION_LOGON 'A user has logged on to the session
                  Form1.Text1.Text = Form1.Text1.Text & lParam & "'s Session was Logged ON"
               Case WTS_SESSION_LOGOFF 'A user has logged off the session
                  Form1.Text1.Text = Form1.Text1.Text & lParam & "'s Session was Logged OFF"
               Case WTS_SESSION_LOCK 'A session has been Locked
                  Form1.Text1.Text = Form1.Text1.Text & lParam & "'s Session was Locked"
               Case WTS_SESSION_UNLOCK 'A session has been unlocked
                  Form1.Text1.Text = Form1.Text1.Text & lParam & "'s Session was Un-Locked"
               Case WTS_SESSION_REMOTE_CONTROL 'A session has changed its remote controlled status
                  Form1.Text1.Text = Form1.Text1.Text & lParam & "'s Remote Status has Changed"
               Case Else
            End Select
            WindowProc = 0 'We processed the message so clear it
         
         Case Else
            If defWindowProc <> 0 Then WindowProc = CallWindowProc(defWindowProc, hwnd, uMsg, wParam, lParam)
            Exit Function
      End Select
   Case Else
      If defWindowProc <> 0 Then WindowProc = CallWindowProc(defWindowProc, hwnd, uMsg, wParam, lParam)
End Select

End Function


Public Sub SubClassSession(ByVal TF As Boolean)
Const GWL_WNDPROC As Long = -4
If TF Then
   'assign window message procedure (WindowProc)
   If defWindowProc = 0 Then defWindowProc = SetWindowLong(Form1.hwnd, GWL_WNDPROC, AddressOf WindowProc)
Else
   'restore the default message handling
   If defWindowProc <> 0 Then
      SetWindowLong Form1.hwnd, GWL_WNDPROC, defWindowProc
      defWindowProc = 0
   End If
End If
End Sub




